/*
 * See the dyninst/COPYRIGHT file for copyright information.
 * 
 * We provide the Paradyn Tools (below described as "Paradyn")
 * on an AS IS basis, and do not warrant its validity or performance.
 * We reserve the right to update, modify, or discontinue this
 * software at any time.  We shall have no obligation to supply such
 * updates or modifications or any other form of support to you.
 * 
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */
#define yy_create_buffer dynC_create_buffer
#define yy_delete_buffer dynC_delete_buffer
#define yy_scan_buffer dynC_scan_buffer
#define yy_scan_string dynC_scan_string
#define yy_scan_bytes dynC_scan_bytes
#define yy_flex_debug dynC_flex_debug
#define yy_init_buffer dynC_init_buffer
#define yy_flush_buffer dynC_flush_buffer
#define yy_load_buffer_state dynC_load_buffer_state
#define yy_switch_to_buffer dynC_switch_to_buffer
#define yyin dynCin
#define yyleng dynCleng
#define yylex dynClex
#define yyout dynCout
#define yyrestart dynCrestart
#define yytext dynCtext
#define yylineno dynClineno

/* A lexical scanner generated by flex*/

/* Scanner skeleton version:
 * $Header: /home/daffy/u0/vern/flex/RCS/flex.skl,v 2.91 96/09/10 16:58:48 vern Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>
#include <unistd.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* Some routines like yy_flex_realloc() are emitted as static but are
   not called by all lexers. This generates warnings in some compilers,
   notably GCC. Arrange to suppress these. */
#ifdef __GNUC__
#define YY_MAY_BE_UNUSED __attribute__((unused))
#else
#define YY_MAY_BE_UNUSED
#endif

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
	};

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO(( FILE *input_file ));

void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));
void yy_flush_buffer YY_PROTO(( YY_BUFFER_STATE b ));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO(( char *base, yy_size_t size ));
YY_BUFFER_STATE yy_scan_string YY_PROTO(( yyconst char *yy_str ));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO(( yyconst char *bytes, int len ));

static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t )) YY_MAY_BE_UNUSED;
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)


#define YY_USES_REJECT

#define yywrap() 1
#define YY_SKIP_YYWRAP
typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern int yylineno;
int yylineno = 1;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yy_fatal_error YY_PROTO(( yyconst char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 107
#define YY_END_OF_BUFFER 108
static yyconst short int yy_acclist[716] =
    {   0,
        1,    1,  108,  106,  107,  103,  106,  107,  105,  107,
       90,  106,  107,   42,  106,  107,   96,  106,  107,   89,
      106,  107,  106,  107,   84,  106,  107,   85,  106,  107,
       94,  106,  107,   93,  106,  107,   81,  106,  107,   92,
      106,  107,   88,  106,  107,   95,  106,  107,   34,   37,
      106,  107,   34,   37,  106,  107,   82,  106,  107,   76,
      106,  107,   97,  106,  107,   83,  106,  107,   98,  106,
      107,  101,  106,  107,   33,  106,  107,   33,  106,  107,
       33,  106,  107,   86,  106,  107,   87,  106,  107,   99,
      106,  107,  102,  106,  107,   33,  106,  107,   33,  106,

      107,   33,  106,  107,   33,  106,  107,   33,  106,  107,
       33,  106,  107,   33,  106,  107,   33,  106,  107,   33,
      106,  107,   33,  106,  107,   33,  106,  107,   33,  106,
      107,   33,  106,  107,   33,  106,  107,   77,  106,  107,
      100,  106,  107,   78,  106,  107,   91,  106,  107,  106,
      107,  103,  106,  107,   90,  106,  107,   42,  106,  107,
       96,  106,  107,   89,  106,  107,  106,  107,   84,  106,
      107,   85,  106,  107,   94,  106,  107,   93,  106,  107,
       81,  106,  107,   92,  106,  107,   88,  106,  107,   95,
      106,  107,   34,   37,  106,  107,   34,   37,  106,  107,

       82,  106,  107,   97,  106,  107,   83,  106,  107,   98,
      106,  107,  101,  106,  107,   33,  106,  107,   33,  106,
      107,   33,  106,  107,   86,  106,  107,   87,  106,  107,
       99,  106,  107,  102,  106,  107,   33,  106,  107,   33,
      106,  107,   33,  106,  107,   33,  106,  107,   33,  106,
      107,   33,  106,  107,   33,  106,  107,   33,  106,  107,
       33,  106,  107,   33,  106,  107,   33,  106,  107,   33,
      106,  107,   33,  106,  107,   33,  106,  107,  100,  106,
      107,   91,  106,  107,    1,  107,    3,  107,    2,  107,
       53,  107,   44,  107,   43,  107,  107,   75,   61,   78,

       80,   70,   62,   59,   67,   57,   68,   34,   58,   69,
       40,    6,    5,   60,   41,   34,   36,   37,   37,   34,
       37,   77,   66,   72,   74,   73,   65,   33,   33,   63,
       33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
       33,   33,   33,   16,   33,   33,   33,   33,   33,   33,
       33,   33,   33,   33,   33,   33,   33,   79,   64,   71,
      104,   75,   61,   78,   70,   62,  104,   59,   67,   57,
       68,   34,   58,   69,   40,    6,    5,   60,   41,   34,
       36,   37,   37,   34,   37,   77,   66,   72,   74,   73,
       65,   33,   33,   63,   33,   33,   33,   33,   33,   33,

       33,   33,   33,   33,   33,   33,   33,   16,   33,   33,
       33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
       33,   64,   71,    1,    2,    2,    4,   53,   52,   45,
       46,   52,   46,   52,   50,   52,   51,   52,   47,   52,
       49,   52,   48,   52,   38,   54,   40,    5,   40,   41,
       41,   36,   37,   39,   35,   56,   55,   33,   33,   33,
       33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
       33,   33,    7,   33,   33,   33,   33,   31,   33,   33,
       33,   33,   33,   33,   33,   33,   33,   33,   33,   38,
       54,   40,    5,   40,   41,   41,   36,   37,   39,   35,

       56,   55,   33,   33,   33,   33,   33,   33,   33,   33,
       33,   33,   33,   33,   33,   33,   33,    7,   33,   33,
       33,   33,   31,   33,   33,   33,   33,   33,   33,   33,
       33,   33,   33,   33,   45,   46,   46,   40,   40,   41,
       41,   39,   35,   32,   33,   12,   33,    7,   33,   33,
       33,   33,   33,   15,   33,   11,   33,   33,   33,   29,
       33,   33,   28,   33,   33,   33,   33,   33,   33,   33,
       33,   33,   22,   33,   33,   33,   40,   40,   41,   41,
       39,   35,   32,   33,   12,   33,    7,   33,   33,   33,
       33,   33,   15,   33,   11,   33,   33,   33,   29,   33,

       33,   28,   33,   33,   33,   33,   33,   33,   33,   33,
       33,   22,   33,   33,   33,   45,   46,   40,   41,    8,
       13,   33,   33,   33,   33,   23,   33,   33,   33,   24,
       33,   25,   33,   33,   33,   33,   33,   33,   33,   10,
       33,   40,   41,    8,   13,   33,   33,   33,   33,   23,
       33,   33,   33,   24,   33,   25,   33,   33,   33,   33,
       33,   33,   33,   10,   33,   33,   33,   33,   26,   33,
       17,   33,   18,   33,   19,   33,    9,   33,   20,   33,
       33,   33,   33,   33,   26,   33,   17,   33,   18,   33,
       19,   33,    9,   33,   20,   33,   33,   14,   33,   27,

       33,   33,   21,   33,   14,   33,   27,   33,   33,   21,
       33,   30,   33,   30,   33
    } ;

static yyconst short int yy_accept[482] =
    {   0,
        1,    1,    1,    2,    3,    3,    3,    4,    6,    9,
       11,   14,   17,   20,   23,   25,   28,   31,   34,   37,
       40,   43,   46,   49,   53,   57,   60,   63,   66,   69,
       72,   75,   78,   81,   84,   87,   90,   93,   96,   99,
      102,  105,  108,  111,  114,  117,  120,  123,  126,  129,
      132,  135,  138,  141,  144,  147,  150,  152,  155,  158,
      161,  164,  167,  169,  172,  175,  178,  181,  184,  187,
      190,  193,  197,  201,  204,  207,  210,  213,  216,  219,
      222,  225,  228,  231,  234,  237,  240,  243,  246,  249,
      252,  255,  258,  261,  264,  267,  270,  273,  276,  279,

      282,  285,  287,  289,  291,  293,  295,  297,  298,  299,
      300,  301,  302,  303,  304,  304,  304,  305,  306,  307,
      308,  309,  310,  311,  311,  312,  313,  314,  315,  316,
      319,  319,  320,  320,  322,  323,  324,  325,  326,  327,
      328,  329,  329,  330,  331,  332,  333,  334,  335,  336,
      337,  338,  339,  340,  341,  342,  343,  344,  346,  347,
      348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
      358,  359,  360,  361,  361,  362,  363,  364,  365,  366,
      367,  367,  368,  368,  369,  370,  371,  372,  373,  374,
      375,  375,  376,  377,  378,  379,  380,  383,  383,  384,

      384,  386,  387,  388,  389,  390,  391,  392,  393,  393,
      394,  395,  396,  397,  398,  399,  400,  401,  402,  403,
      404,  405,  406,  407,  408,  410,  411,  412,  413,  414,
      415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
      425,  426,  427,  428,  429,  430,  433,  435,  437,  439,
      441,  443,  445,  446,  447,  447,  448,  449,  451,  451,
      452,  454,  454,  455,  456,  457,  458,  459,  460,  461,
      462,  463,  464,  465,  466,  467,  468,  469,  470,  471,
      472,  473,  475,  476,  477,  478,  480,  481,  482,  483,
      484,  485,  486,  487,  488,  489,  490,  491,  492,  492,

      493,  494,  496,  496,  497,  499,  499,  500,  501,  502,
      503,  504,  505,  506,  507,  508,  509,  510,  511,  512,
      513,  514,  515,  516,  517,  518,  520,  521,  522,  523,
      525,  526,  527,  528,  529,  530,  531,  532,  533,  534,
      535,  537,  538,  538,  539,  539,  541,  541,  542,  543,
      544,  546,  548,  550,  551,  552,  553,  554,  556,  558,
      559,  560,  562,  563,  565,  566,  567,  568,  569,  570,
      571,  572,  573,  575,  576,  577,  577,  578,  578,  580,
      580,  581,  582,  583,  585,  587,  589,  590,  591,  592,
      593,  595,  597,  598,  599,  601,  602,  604,  605,  606,

      607,  608,  609,  610,  611,  612,  614,  615,  616,  618,
      618,  620,  620,  621,  623,  624,  625,  626,  628,  629,
      630,  632,  634,  635,  636,  637,  638,  639,  640,  642,
      642,  644,  644,  645,  647,  648,  649,  650,  652,  653,
      654,  656,  658,  659,  660,  661,  662,  663,  664,  666,
      667,  668,  669,  671,  673,  675,  677,  679,  681,  682,
      683,  684,  685,  687,  689,  691,  693,  695,  697,  698,
      700,  702,  703,  705,  707,  709,  710,  712,  714,  716,
      716
    } ;

static yyconst int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        2,    2,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    4,    5,    1,    1,    6,    7,    8,    9,
       10,   11,   12,   13,   14,   15,   16,   17,   18,   18,
       18,   18,   18,   18,   18,   19,   19,   20,   21,   22,
       23,   24,   25,    1,   26,   26,   26,   26,   27,   28,
       29,   29,   29,   29,   29,   30,   29,   31,   29,   29,
       29,   29,   29,   29,   32,   29,   29,   33,   29,   29,
       34,   35,   36,   37,   38,   39,   40,   41,   42,   43,

       44,   45,   46,   47,   48,   29,   29,   49,   50,   51,
       52,   53,   29,   54,   55,   56,   57,   58,   59,   33,
       60,   61,   62,   63,   64,   65,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst int yy_meta[66] =
    {   0,
        1,    1,    2,    1,    3,    1,    1,    4,    1,    1,
        5,    1,    1,    1,    1,    1,    6,    6,    6,    1,
        7,    1,    1,    1,    1,    6,    6,    6,    8,    8,
        8,    8,    8,    1,    3,    1,    1,    8,    1,    6,
        6,    6,    6,    6,    6,    8,    8,    8,    8,    8,
        8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
        8,    7,    1,    7,    1
    } ;

static yyconst short int yy_base[494] =
    {   0,
        0,   65,  128,  129,  130,  131, 1038, 1039, 1039, 1039,
     1014, 1039,  114,  134, 1001, 1039, 1039, 1012,  130, 1039,
      131,  141,  151,  164,  151, 1039, 1039,  141, 1011,  120,
     1039,    0, 1025, 1000, 1039, 1039, 1008, 1039,  978,  133,
      143,  126,  149,  980,  101,  976,  987,  982,  145,  145,
      974,  972, 1017,  148, 1039, 1039, 1019, 1018,  187, 1017,
      199,  209,  206, 1016, 1015,  197,  212, 1014,  225,  235,
      214,  268,  323, 1013,  223,  228,  233, 1012,  380, 1006,
      981, 1009, 1008,  237, 1007,  957,  215,  214,  137,  224,
      959,  214,  955,  966,  961,  232,  215,  953,  951,  269,

      999,    0, 1039,  266,    0, 1039, 1039,  292, 1039, 1039,
     1039, 1039, 1039, 1039,  199,  281, 1039, 1039, 1039, 1039,
      285, 1039, 1039,  986,  317, 1039,    0, 1039,  429,  264,
      310,  319,    0,    0, 1039,  977, 1039, 1039, 1039,  976,
        0,  963,  967, 1039,  944,  940,  954,  942,  947,  934,
      939,  934,  931,  938,  934,  934,  932,    0,  163,  248,
      929,  105,  930,  920,  193,  932,  922,  925,  929,  928,
     1039, 1039, 1039,  972, 1039,  971,  970,  969,  968,  967,
      441,  270,  447,  966,  965,  964,  963,  356,  962,  961,
      303,  509,  960,  451,  959,  556,  603,  452,  449,  658,

      701,  958,  316,  957,  956,  955,  354,    0,  479,  927,
      953,  903,  899,  913,  901,  906,  893,  898,  893,  890,
      897,  893,  893,  877,    0,  252,  272,  860,  274,  861,
      844,  316,  852,  840,  833,  830,  824,  848,  847,    0,
      347,  349, 1039,    0, 1039,  466,  471, 1039, 1039, 1039,
     1039, 1039, 1039, 1039,  504, 1039,    0,  533,  528, 1039,
      322,  474,  562,  445, 1039, 1039,  819,  798,  802,  791,
      789,  803,  801,  793,  796,  789,  783,  797,  794,  794,
      776,    0,  789,  782,  787,    0,  769,  771,  780,  767,
      762,  762,  773,  772,  762,  769,  808,  807,  552,  806,

      527,  756,  585,  805,  582,  514,  606,  583,  804,  796,
      768,  743,  747,  736,  734,  748,  746,  737,  738,  731,
      722,  732,  728,  728,  712,    0,  724,  717,  717,    0,
      699,  701,  704,  691,  687,  687,  695,  694,  684,  687,
      478,  576,  609,  661,  631, 1039,  639,  664, 1039,  614,
        0,    0,  367,  673,  670,  675,  666,    0,    0,  671,
      658,  656,  671,    0,  659,  655,  643,  640,  643,  645,
      648,  646,    0,  644,  619,  650,  704,  723,  659,  743,
      748,  656,  722,    0,    0,  440,  598,  585,  592,  587,
        0,    0,  593,  573,  563,  577,    0,  567,  560,  554,

      542,  544,  539,  534,  530,    0,  525,  516,  647,  655,
      785,  456, 1039,    0,  513,  505,  489,    0,  490,  486,
        0,    0,  483,  484,  483,  468,  473,  475,    0,  777,
      803,  554,  507,    0,  459,  463,  449,    0,  453,  450,
        0,    0,  435,  435,  423,  407,  414,  416,    0,  397,
      345,  312,    0,    0,    0,    0,    0,    0,  286,  260,
      259,  241,    0,    0,    0,    0,    0,    0,  231,    0,
        0,  210,    0,    0,    0,  125,    0,    0,    0, 1039,
      852,  860,  868,  871,  879,  887,  895,  903,  911,  919,
      927,  166,  935

    } ;

static yyconst short int yy_def[494] =
    {   0,
      480,  480,  481,  481,  482,  482,  480,  480,  480,  480,
      480,  480,  480,  480,  483,  480,  480,  480,  480,  480,
      480,  480,  480,  480,   24,  480,  480,  480,  480,  480,
      480,  484,  484,  484,  480,  480,  480,  480,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  480,  480,  480,  480,  485,  485,  485,  485,
      485,  485,  486,  485,  485,  485,  485,  485,  485,  485,
      485,  485,  485,  485,  485,  485,  485,  485,  480,   79,
       79,  485,  485,  485,  485,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,  485,

      485,  487,  480,  488,  489,  480,  480,  490,  480,  480,
      480,  480,  480,  480,  483,  483,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  491,  480,  480,   24,
      480,  480,  492,   25,  480,  480,  480,  480,  480,  480,
      484,  483,  484,  480,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      480,  480,  480,  485,  480,  485,  485,  485,  485,  485,
      486,  483,  486,  485,  485,  485,  485,  485,  485,  485,
      485,  485,  485,  493,  485,  485,  485,  485,  485,  485,

      485,  485,  485,  485,  485,  485,  485,   79,  486,   79,
      485,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,  485,  485,  487,
      488,  488,  480,  489,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  491,  480,  480,  480,
      480,  480,  480,  492,  480,  480,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  485,  485,  485,  485,

      493,  485,  485,  485,  485,  485,  485,  200,  485,  485,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  485,  485,  485,  485,  485,
      485,  485,  485,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,

       79,   79,   79,   79,   79,   79,   79,   79,  480,  480,
      480,  480,  480,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  485,
      485,  485,  485,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,  484,
      484,  484,  484,   79,   79,   79,   79,  484,   79,    0,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480

    } ;

static yyconst short int yy_nxt[1105] =
    {   0,
        8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
       18,   19,   20,   21,   22,   23,   24,   25,   25,   26,
       27,   28,   29,   30,   31,   32,   32,   32,   32,   33,
       34,   32,   32,   35,    8,   36,   37,    8,   38,   32,
       39,   40,   41,   42,   43,   44,   32,   45,   46,   32,
       32,   32,   47,   48,   49,   50,   51,   52,   32,   32,
       32,   53,   54,   55,   56,   57,   58,   10,   59,   60,
       61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
       71,   72,   73,   73,   74,   27,   75,   76,   77,   78,
       79,   79,   79,   79,   80,   81,   79,   79,   82,   57,

       83,   84,   57,   85,   79,   86,   87,   88,   89,   90,
       91,   79,   92,   93,   79,   79,   79,   94,   95,   96,
       97,   98,   99,   79,   79,   79,   53,  100,   55,  101,
      103,  103,  106,  106,  107,  107,  110,  111,  104,  104,
      113,  118,  139,  140,  120,  158,  135,  121,  121,  121,
      286,  159,  119,  122,  123,  124,  114,  125,  125,  125,
      287,  126,  136,  137,  108,  108,  127,  134,  134,  134,
      172,  264,  146,  128,  152,  479,  153,  112,  129,  147,
      130,  130,  130,  480,  148,  219,  149,  220,  154,  175,
      131,  163,  164,  132,  150,  132,  133,  155,  167,  175,

      165,  175,  151,  166,  168,  156,  253,  131,  182,  176,
      173,  175,  132,  174,  175,  179,  175,  281,  282,  184,
      132,  177,  178,  185,  193,  175,  115,  175,  202,  194,
      175,  180,  290,  116,  186,  175,  195,  175,  187,  175,
      183,  188,  188,  188,  203,  204,  291,  189,  190,  191,
      205,  192,  192,  192,  213,  206,  207,  216,  225,  211,
      478,  214,  112,  221,  226,  217,  215,  115,  234,  115,
      175,  175,  222,  218,  235,  477,  242,  253,  230,  231,
      223,  243,  196,  480,  197,  197,  197,  232,  115,  283,
      233,  238,  476,  261,  198,  261,  480,  199,  284,  199,

      200,  121,  121,  121,  116,  175,  325,  326,  246,  246,
      247,  198,  261,  327,  475,  474,  199,  298,  175,  330,
      261,  262,  328,  262,  199,  175,  263,  263,  263,  331,
      473,  239,  248,  125,  125,  125,  249,  196,  309,  201,
      201,  201,  250,  255,  256,  251,  256,  252,  132,  198,
      132,  261,  199,  261,  199,  334,  175,  480,  175,  242,
      255,  256,  480,  472,  243,  256,  198,  132,  412,  335,
      261,  199,  188,  188,  188,  132,  310,  413,  261,  199,
      174,  174,  175,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  208,  208,  208,  174,

      471,  174,  174,  174,  174,  208,  208,  208,  208,  208,
      208,  208,  208,  174,  174,  174,  174,  208,  174,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  432,  174,  182,  174,  258,  258,  258,  297,  175,
      433,  175,  470,  175,  175,  259,  260,  412,  260,  469,
      468,  115,  467,  306,  466,  306,  413,  115,  307,  307,
      307,  257,  259,  260,  350,  183,  350,  260,  199,  465,
      199,  182,  341,  341,  342,  464,  174,  342,  342,  342,
      263,  263,  263,  350,  409,  409,  342,  199,  463,  115,

      462,  350,  115,  461,  115,  199,  326,  460,  115,  175,
      115,  175,  257,  183,  257,  343,  175,  343,  459,  458,
      344,  344,  344,  457,  456,  192,  192,  192,  455,  175,
      307,  307,  307,  454,  453,  299,  300,  452,  300,  347,
      115,  347,  115,  451,  348,  348,  348,  257,  282,  258,
      258,  258,  299,  300,  175,  432,  175,  300,  175,  345,
      346,  450,  346,  376,  433,  376,  449,  448,  377,  377,
      377,  447,  302,  302,  302,  446,  345,  346,  263,  263,
      263,  346,  303,  304,  175,  304,  445,  175,  257,  349,
      257,  349,  342,  342,  342,  444,  380,  326,  380,  303,

      304,  381,  381,  381,  304,  175,  349,  443,  175,  442,
      349,  305,  383,  305,  383,  441,  440,  196,  439,  197,
      197,  197,  307,  307,  307,  344,  344,  344,  326,  198,
      305,  383,  305,  382,  305,  382,  438,  437,  305,  383,
      436,  435,  410,  350,  410,  350,  198,  411,  411,  411,
      382,  305,  175,  434,  382,  348,  348,  348,  175,  305,
      175,  175,  350,  342,  342,  342,  377,  377,  377,  429,
      350,  411,  411,  411,  308,  308,  308,  344,  344,  344,
      348,  348,  348,  308,  308,  308,  428,  427,  256,  426,
      256,  260,  425,  260,  424,  282,  423,  308,  308,  308,

      308,  308,  308,  175,  422,  256,  175,  421,  260,  256,
      420,  419,  260,  282,  418,  196,  417,  201,  201,  201,
      377,  377,  377,  416,  175,  175,  415,  198,  414,  326,
      199,  300,  199,  300,  430,  408,  430,  407,  406,  431,
      431,  431,  405,  404,  198,  175,  403,  402,  300,  199,
      175,  383,  300,  383,  401,  400,  399,  199,  175,  381,
      381,  381,  326,  398,  381,  381,  381,  397,  396,  395,
      383,  394,  302,  302,  302,  304,  393,  304,  383,  175,
      392,  391,  378,  379,  390,  379,  389,  388,  387,  386,
      385,  326,  304,  431,  431,  431,  304,  384,  175,  378,

      379,  411,  411,  411,  379,  175,  175,  175,  175,  175,
      175,  282,  346,  375,  346,  374,  373,  372,  371,  431,
      431,  431,  370,  369,  368,  367,  366,  282,  365,  346,
      379,  364,  379,  346,  363,  362,  361,  360,  359,  358,
      357,  356,  355,  354,  353,  352,  282,  379,  351,  175,
      175,  379,  102,  102,  102,  102,  102,  102,  102,  102,
      105,  105,  105,  105,  105,  105,  105,  105,  115,  115,
      115,  340,  115,  115,  115,  115,  141,  339,  141,  174,
      174,  174,  174,  174,  174,  338,  174,  181,  181,  181,
      181,  181,  181,  181,  181,  240,  337,  240,  240,  336,

      240,  240,  240,  241,  333,  241,  241,  241,  241,  241,
      241,  244,  332,  329,  244,  244,  244,  244,  244,  245,
      245,  245,  245,  245,  245,  245,  245,  257,  324,  257,
      257,  257,  257,  257,  257,  301,  301,  301,  301,  301,
      301,  301,  301,  323,  322,  321,  320,  319,  318,  317,
      316,  315,  314,  313,  312,  175,  311,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  296,  295,  294,  293,  292,
      289,  288,  285,  280,  279,  278,  277,  276,  275,  274,
      273,  272,  271,  270,  269,  268,  267,  116,  266,  265,

      254,  175,  237,  236,  229,  228,  227,  224,  212,  175,
      175,  175,  210,  209,  175,  175,  175,  175,  175,  175,
      175,  175,  171,  170,  169,  162,  161,  160,  157,  145,
      144,  143,  142,  138,  117,  116,  109,  480,    7,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,

      480,  480,  480,  480
    } ;

static yyconst short int yy_chk[1105] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        3,    4,    5,    6,    5,    6,   13,   13,    3,    4,
       14,   19,   30,   30,   21,   45,   28,   21,   21,   21,
      162,   45,   19,   21,   21,   22,   14,   22,   22,   22,
      162,   23,   28,   28,    5,    6,   23,   25,   25,   25,
       54,  492,   40,   23,   42,  476,   42,   13,   24,   40,
       24,   24,   24,   25,   40,   89,   41,   89,   43,   59,
       24,   49,   49,   24,   41,   24,   24,   43,   50,   66,

       49,   61,   41,   49,   50,   43,  115,   24,   63,   59,
       54,   62,   24,   63,   67,   62,   71,  159,  159,   66,
       24,   61,   61,   67,   71,   75,   63,   69,   75,   71,
       76,   62,  165,  115,   67,   77,   71,   70,   69,   84,
       63,   69,   69,   69,   75,   75,  165,   69,   69,   70,
       76,   70,   70,   70,   87,   77,   77,   88,   92,   84,
      472,   87,   61,   90,   92,   88,   87,   63,   97,   63,
       72,  100,   90,   88,   97,  469,  104,  182,   96,   96,
       90,  104,   72,  116,   72,   72,   72,   96,  116,  160,
       96,  100,  462,  130,   72,  130,  130,   72,  160,   72,

       72,  121,  121,  121,  182,  191,  226,  226,  108,  108,
      108,   72,  130,  227,  461,  460,   72,  191,  203,  229,
      130,  131,  227,  131,   72,   73,  131,  131,  131,  229,
      459,  100,  108,  125,  125,  125,  108,   73,  203,   73,
       73,   73,  108,  125,  125,  108,  125,  108,  132,   73,
      132,  261,   73,  261,   73,  232,  207,  241,  188,  242,
      125,  125,  241,  452,  242,  125,   73,  132,  353,  232,
      261,   73,  188,  188,  188,  132,  207,  353,  261,   73,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,

      451,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,  386,   79,  181,   79,  129,  129,  129,  181,  183,
      386,  199,  450,  194,  198,  129,  129,  412,  129,  448,
      447,  181,  446,  198,  445,  198,  412,  183,  198,  198,
      198,  194,  129,  129,  264,  181,  264,  129,  199,  444,
      199,  209,  246,  246,  246,  443,  209,  247,  247,  247,
      262,  262,  262,  264,  341,  341,  341,  199,  440,  209,

      439,  264,  181,  437,  181,  199,  436,  435,  183,  433,
      183,  192,  194,  209,  194,  255,  306,  255,  428,  427,
      255,  255,  255,  426,  425,  192,  192,  192,  424,  301,
      306,  306,  306,  423,  420,  192,  192,  419,  192,  259,
      209,  259,  209,  417,  259,  259,  259,  301,  416,  258,
      258,  258,  192,  192,  299,  432,  432,  192,  196,  258,
      258,  415,  258,  299,  432,  299,  408,  407,  299,  299,
      299,  405,  196,  196,  196,  404,  258,  258,  263,  263,
      263,  258,  196,  196,  305,  196,  403,  303,  301,  263,
      301,  263,  342,  342,  342,  402,  303,  401,  303,  196,

      196,  303,  303,  303,  196,  197,  263,  400,  307,  399,
      263,  305,  308,  305,  308,  398,  396,  197,  395,  197,
      197,  197,  307,  307,  307,  343,  343,  343,  394,  197,
      305,  308,  197,  307,  197,  307,  393,  390,  305,  308,
      389,  388,  345,  350,  345,  350,  197,  345,  345,  345,
      307,  197,  376,  387,  307,  347,  347,  347,  382,  197,
      200,  379,  350,  409,  409,  409,  376,  376,  376,  375,
      350,  410,  410,  410,  200,  200,  200,  344,  344,  344,
      348,  348,  348,  200,  200,  200,  374,  372,  344,  371,
      344,  348,  370,  348,  369,  368,  367,  200,  200,  200,

      200,  200,  200,  201,  366,  344,  377,  365,  348,  344,
      363,  362,  348,  361,  360,  201,  357,  201,  201,  201,
      377,  377,  377,  356,  383,  378,  355,  201,  354,  340,
      201,  377,  201,  377,  378,  339,  378,  338,  337,  378,
      378,  378,  336,  335,  201,  380,  334,  333,  377,  201,
      381,  383,  377,  383,  332,  331,  329,  201,  302,  380,
      380,  380,  328,  327,  381,  381,  381,  325,  324,  323,
      383,  322,  302,  302,  302,  381,  321,  381,  383,  430,
      320,  319,  302,  302,  318,  302,  317,  316,  315,  314,
      313,  312,  381,  430,  430,  430,  381,  311,  310,  302,

      302,  411,  411,  411,  302,  431,  309,  304,  300,  298,
      297,  296,  411,  295,  411,  294,  293,  292,  291,  431,
      431,  431,  290,  289,  288,  287,  285,  284,  283,  411,
      431,  281,  431,  411,  280,  279,  278,  277,  276,  275,
      274,  273,  272,  271,  270,  269,  268,  431,  267,  239,
      238,  431,  481,  481,  481,  481,  481,  481,  481,  481,
      482,  482,  482,  482,  482,  482,  482,  482,  483,  483,
      483,  237,  483,  483,  483,  483,  484,  236,  484,  485,
      485,  485,  485,  485,  485,  235,  485,  486,  486,  486,
      486,  486,  486,  486,  486,  487,  234,  487,  487,  233,

      487,  487,  487,  488,  231,  488,  488,  488,  488,  488,
      488,  489,  230,  228,  489,  489,  489,  489,  489,  490,
      490,  490,  490,  490,  490,  490,  490,  491,  224,  491,
      491,  491,  491,  491,  491,  493,  493,  493,  493,  493,
      493,  493,  493,  223,  222,  221,  220,  219,  218,  217,
      216,  215,  214,  213,  212,  211,  210,  206,  205,  204,
      202,  195,  193,  190,  189,  187,  186,  185,  184,  180,
      179,  178,  177,  176,  174,  170,  169,  168,  167,  166,
      164,  163,  161,  157,  156,  155,  154,  153,  152,  151,
      150,  149,  148,  147,  146,  145,  143,  142,  140,  136,

      124,  101,   99,   98,   95,   94,   93,   91,   86,   85,
       83,   82,   81,   80,   78,   74,   68,   65,   64,   60,
       58,   57,   53,   52,   51,   48,   47,   46,   44,   39,
       37,   34,   33,   29,   18,   15,   11,    7,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,

      480,  480,  480,  480
    } ;

static yy_state_type yy_state_buf[YY_BUF_SIZE + 2], *yy_state_ptr;
static char *yy_full_match;
static int yy_lp;
#define REJECT \
{ \
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */ \
yy_cp = yy_full_match; /* restore poss. backed-over text */ \
++yy_lp; \
goto find_rule; \
}
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "../src/C.l"
#define INITIAL 0
#define YY_NO_UNPUT 1
#define comment 1

#define stringmode 2

#line 15 "../src/C.l"

#include <stdio.h>
#include <string>
#include "BPatch_snippet.h"
#include <vector>
#include "dynC.tab.h"
#include "snippetGen.h"

int line_num = 1;

extern "C" {
  void set_lex_input(char *);
}

std::string lineStr;
static char *input_str = NULL;  


int yycolumn = 0;

extern bool fatalError;



#define YY_USER_ACTION dynClloc.first_line = dynClloc.last_line = line_num;\
        dynClloc.first_column = yycolumn; dynClloc.last_column = yycolumn+yyleng-1;\
        yycolumn += yyleng;\
        lineStr = yytext;

#define input() (*input_str++)
//#define yyinput() (*input_str++)
#define yylval dynClval

std::string c_string_buf = "";

const bool lexVerbose = false; // set to true for debug mode

//"$"{L}({L}|{D})* { yylval.sval = &yytext[1]; return(DYNINST_CALL); }

#line 936 "lex.dynC.c"

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO(( void ));
#else
extern int yywrap YY_PROTO(( void ));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO(( int c, char *buf_ptr ));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO(( yyconst char * ));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO(( int new_state ));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO(( void ));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO(( void ));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		yy_current_buffer->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

YY_DECL
	{
	register yy_state_type yy_current_state;
	register char *yy_cp = NULL, *yy_bp = NULL;
	register int yy_act;

#line 56 "../src/C.l"


#line 1093 "lex.dynC.c"

	if ( yy_init )
		{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yy_start )
			yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! yy_current_buffer )
			yy_current_buffer =
				yy_create_buffer( yyin, YY_BUF_SIZE );

		yy_load_buffer_state();
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
		yy_current_state += YY_AT_BOL();
		yy_state_ptr = yy_state_buf;
		*yy_state_ptr++ = yy_current_state;
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 481 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			*yy_state_ptr++ = yy_current_state;
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 1039 );

yy_find_action:
		yy_current_state = *--yy_state_ptr;
		yy_lp = yy_accept[yy_current_state];
find_rule: /* we branch to this label when backing up */
		for ( ; ; ) /* until we find what rule we matched */
			{
			if ( yy_lp && yy_lp < yy_accept[yy_current_state + 1] )
				{
				yy_act = yy_acclist[yy_lp];
					{
					yy_full_match = yy_cp;
					break;
					}
				}
			--yy_cp;
			yy_current_state = *--yy_state_ptr;
			yy_lp = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					++yylineno;
			}

do_action:	/* This label is used only to access EOF actions. */


		switch ( yy_act )
	{ /* beginning of action switch */

case 1:
YY_RULE_SETUP
#line 60 "../src/C.l"
/* eat anything that's not a '*' */ 
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 61 "../src/C.l"
/* eat up '*'s not followed by '/'s */                           
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 62 "../src/C.l"
++line_num;                                                      
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 63 "../src/C.l"
BEGIN(INITIAL);       
	YY_BREAK
case YY_STATE_EOF(comment):
#line 64 "../src/C.l"
{yylval.context = "Syntax Error: Unterminated block comment"; return(ERROR);}
	YY_BREAK

case 5:
YY_RULE_SETUP
#line 67 "../src/C.l"
{ if(lexVerbose)printf("Inline Comment\n") /* inline comment */;}                            
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 68 "../src/C.l"
{ BEGIN(comment); }                                                  
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 70 "../src/C.l"
{ yylval.sval = strdup(yytext); return TYPE;}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 71 "../src/C.l"
{yylval.sval = "char *"; return TYPE; }
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 73 "../src/C.l"
{return STRUCT; }
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 74 "../src/C.l"
{return UNION; }
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 75 "../src/C.l"
{return ENUM; }
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 77 "../src/C.l"
{ return(CASE); }
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 78 "../src/C.l"
{ return(CONST); }
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 79 "../src/C.l"
{ return(DEFAULT); }
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 80 "../src/C.l"
{ return(ELSE); }
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 81 "../src/C.l"
{ return(IF); }
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 82 "../src/C.l"
{ return(RETURN); }
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 83 "../src/C.l"
{ return(SIZEOF); }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 84 "../src/C.l"
{ return(STATIC); }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 85 "../src/C.l"
{ return(SWITCH); }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 86 "../src/C.l"
{ return(TYPEDEF); }
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 87 "../src/C.l"
{ return(D_TRUE); }
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 88 "../src/C.l"
{ return(D_FALSE); }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 90 "../src/C.l"
{ return(LOCAL); }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 91 "../src/C.l"
{ return(PARAM); }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 92 "../src/C.l"
{ return(GLOBAL); }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 93 "../src/C.l"
{ return(DYNINST); }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 94 "../src/C.l"
{ return(INST); }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 95 "../src/C.l"
{ return(FUNC); }
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 96 "../src/C.l"
{ return(FUNC); }
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 97 "../src/C.l"
{ return(REGISTER); }
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 98 "../src/C.l"
{return (NILL); }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 100 "../src/C.l"
{yylval.sval = strdup(yytext); if(lexVerbose) printf("ID: %s\n", yytext); return(IDENTIFIER); }
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 104 "../src/C.l"
{ yylval.ival = atoi(yytext); return NUMBER;}
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 106 "../src/C.l"
{ return(CONSTANT); }
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 107 "../src/C.l"
{ return(CONSTANT); }
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 108 "../src/C.l"
{ return(CONSTANT); }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 109 "../src/C.l"
{ return(CONSTANT); }
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 111 "../src/C.l"
{ return(CONSTANT); }
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 112 "../src/C.l"
{ return(CONSTANT); }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 113 "../src/C.l"
{ return(CONSTANT); }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 115 "../src/C.l"
{if(lexVerbose)printf("String Mode!\n"); c_string_buf = ""; BEGIN(stringmode);} 
	YY_BREAK

case 43:
YY_RULE_SETUP
#line 119 "../src/C.l"
{ /* saw closing quote - all done */
                  // this string handling code was taken from the flex manual
                  if(lexVerbose)printf("string done\n");
                  BEGIN(INITIAL);                                                    
                  char * cstr = new char[c_string_buf.size() + 1];                   

                  strcpy (cstr, c_string_buf.c_str());                               

                  yylval.sval = strdup(cstr);                                   
                  delete[] cstr;                                                     
                  return STRING;                                                     
                }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 132 "../src/C.l"
{ /* error - unterminated strin constant */
                  yylval.context = "Unterminated string constant";
                  yycolumn = 1;
                  //yylval.line_number = line_num;                                                     line_num++;
                  return ERROR; 
                }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 139 "../src/C.l"
{ /* octal escape sequence */
                  int result;                                                        
                  (void) sscanf( yytext + 1, "%o", &result );                        
                  if ( result > 0xff ){
                      /* error, constant is out-of-bounds */
                      yylval.context = "constant out of bounds";                
                     // yylval.line_number = line_num;                            
                      return ERROR;                                                  
                  }
                  c_string_buf += result;                                            
  
                }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 152 "../src/C.l"
{ /* generate error - bad escape sequence */
                  yylval.context = "bad escape sequence";                       
                 // yylval.line_number = line_num;                                
                  return ERROR;                                                      
                }
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 157 "../src/C.l"
c_string_buf += '\n';                                                
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 158 "../src/C.l"
c_string_buf += '\t';                                                
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 159 "../src/C.l"
c_string_buf += '\r';                                                
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 160 "../src/C.l"
c_string_buf += '\b';                                             
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 161 "../src/C.l"
c_string_buf += '\f';                                                
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 163 "../src/C.l"
c_string_buf += yytext[1];
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 164 "../src/C.l"
{
                  char *yptr = yytext;
                  while ( *yptr ) { c_string_buf += *yptr++; }
                }
	YY_BREAK

case 54:
YY_RULE_SETUP
#line 171 "../src/C.l"
{ return(ELLIPSIS); }
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 172 "../src/C.l"
{ return(RIGHT_ASSIGN); }
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 173 "../src/C.l"
{ return(LEFT_ASSIGN); }
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 174 "../src/C.l"
{ return(ADD_ASSIGN); }
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 175 "../src/C.l"
{ return(SUB_ASSIGN); }
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 176 "../src/C.l"
{ return(MUL_ASSIGN); }
	YY_BREAK
case 60:
YY_RULE_SETUP
#line 177 "../src/C.l"
{ return(DIV_ASSIGN); }
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 178 "../src/C.l"
{ return(MOD_ASSIGN); }
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 179 "../src/C.l"
{ return(AND_ASSIGN); }
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 180 "../src/C.l"
{ return(XOR_ASSIGN); }
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 181 "../src/C.l"
{ return(OR_ASSIGN); }
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 182 "../src/C.l"
{ return(RIGHT_OP); }
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 183 "../src/C.l"
{ return(LEFT_OP); }
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 184 "../src/C.l"
{ return(INC_OP); }
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 185 "../src/C.l"
{ return(DEC_OP); }
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 186 "../src/C.l"
{ return(PTR_OP); }
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 187 "../src/C.l"
{ return(AND); }
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 188 "../src/C.l"
{ return(OR); }
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 189 "../src/C.l"
{ return(LESS_EQ); }
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 190 "../src/C.l"
{ return(GREATER_EQ); }
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 191 "../src/C.l"
{ return(EQ); }
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 192 "../src/C.l"
{ return(NOT_EQ); }
	YY_BREAK
case 76:
YY_RULE_SETUP
#line 193 "../src/C.l"
{ return(SEMI); }
	YY_BREAK
case 77:
YY_RULE_SETUP
#line 194 "../src/C.l"
{ return('{'); }
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 195 "../src/C.l"
{ return('}'); }
	YY_BREAK
case 79:
YY_RULE_SETUP
#line 196 "../src/C.l"
{ return(NOPEN); }
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 197 "../src/C.l"
{ return(NCLOSE); }
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 198 "../src/C.l"
{ return(COMMA); }
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 199 "../src/C.l"
{ return(COLON); }
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 200 "../src/C.l"
{ return(ASSIGN); }
	YY_BREAK
case 84:
YY_RULE_SETUP
#line 201 "../src/C.l"
{ if(lexVerbose)printf("(\n"); return('('); }
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 202 "../src/C.l"
{ if(lexVerbose)printf(")\n"); return(')'); }
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 203 "../src/C.l"
{ return('['); }
	YY_BREAK
case 87:
YY_RULE_SETUP
#line 204 "../src/C.l"
{ return(']'); }
	YY_BREAK
case 88:
YY_RULE_SETUP
#line 205 "../src/C.l"
{ return(DOT); }
	YY_BREAK
case 89:
YY_RULE_SETUP
#line 206 "../src/C.l"
{ return('&'); }
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 207 "../src/C.l"
{ return('!'); }
	YY_BREAK
case 91:
YY_RULE_SETUP
#line 208 "../src/C.l"
{ return('~'); }
	YY_BREAK
case 92:
YY_RULE_SETUP
#line 209 "../src/C.l"
{ return('-'); }
	YY_BREAK
case 93:
YY_RULE_SETUP
#line 210 "../src/C.l"
{ return('+'); }
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 211 "../src/C.l"
{ return('*'); }
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 212 "../src/C.l"
{ return('/'); }
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 213 "../src/C.l"
{ return('%'); }
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 214 "../src/C.l"
{ return('<'); }
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 215 "../src/C.l"
{ return('>'); }
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 216 "../src/C.l"
{ return('^'); }
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 217 "../src/C.l"
{ return('|'); }
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 218 "../src/C.l"
{ return('?'); }
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 219 "../src/C.l"
{ if(lexVerbose)printf("Backtick\n"); return(BACKTICK); }
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 220 "../src/C.l"
{ }
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 222 "../src/C.l"
{if(strstr(yytext, "//") != NULL){++line_num;}else{if(strncmp(yytext,"/*", 2) == 0){BEGIN(comment);++line_num;}else{if(lexVerbose)printf("No Semi!\n"); fatalError = true; dynClloc.first_column = yycolumn; yylval.context = "syntax error: missing ';'!"; yyless(yyleng - 1); return(ERROR);}}}
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 224 "../src/C.l"
{if(lexVerbose)printf("New Line!\n"); line_num++; yycolumn = 0; lineStr = "";}
	YY_BREAK
case 106:
YY_RULE_SETUP
#line 226 "../src/C.l"
{ if(lexVerbose) printf("Unrecognized [%s]\n", yytext); /* ignore bad characters */ }
	YY_BREAK
case 107:
YY_RULE_SETUP
#line 230 "../src/C.l"
ECHO;
	YY_BREAK
#line 1762 "lex.dynC.c"
			case YY_STATE_EOF(INITIAL):
			case YY_STATE_EOF(stringmode):
				yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between yy_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yy_n_chars = yy_current_buffer->yy_n_chars;
			yy_current_buffer->yy_input_file = yyin;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_did_buffer_switch_on_eof = 0;

				if ( yywrap() )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p =
					yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yy_c_buf_p =
				&yy_current_buffer->yy_ch_buf[yy_n_chars];

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()
	{
	register char *dest = yy_current_buffer->yy_ch_buf;
	register char *source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_current_buffer->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_current_buffer->yy_n_chars = yy_n_chars = 0;

	else
		{
		int num_to_read =
			yy_current_buffer->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset =
				(int) (yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yy_flex_realloc( (void *) b->yy_ch_buf,
							 b->yy_buf_size + 2 );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
			yy_n_chars, num_to_read );

		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	if ( yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
	}


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type yy_get_previous_state()
	{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = yy_start;
	yy_current_state += YY_AT_BOL();
	yy_state_ptr = yy_state_buf;
	*yy_state_ptr++ = yy_current_state;

	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 481 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		*yy_state_ptr++ = yy_current_state;
		}

	return yy_current_state;
	}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
yy_state_type yy_current_state;
#endif
	{
	register int yy_is_jam;

	register YY_CHAR yy_c = 1;
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 481 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 480);
	if ( ! yy_is_jam )
		*yy_state_ptr++ = yy_current_state;

	return yy_is_jam ? 0 : yy_current_state;
	}


#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void yyunput( int c, register char *yy_bp )
#else
static void yyunput( c, yy_bp )
int c;
register char *yy_bp;
#endif
	{
	register char *yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
		register char *source =
				&yy_current_buffer->yy_ch_buf[number_to_move];

		while ( source > yy_current_buffer->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		yy_current_buffer->yy_n_chars =
			yy_n_chars = yy_current_buffer->yy_buf_size;

		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

	if ( c == '\n' )
		--yylineno;

	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
	}
#endif	/* ifndef YY_NO_UNPUT */


#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif
	{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			/* This was really a NUL. */
			*yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yy_c_buf_p - yytext_ptr;
			++yy_c_buf_p;

			switch ( yy_get_next_buffer() )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/* fall through */

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap() )
						return EOF;

					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_c_buf_p = yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;

	yy_current_buffer->yy_at_bol = (c == '\n');
	if ( yy_current_buffer->yy_at_bol )
		++yylineno;

	return c;
	}
#endif /* YY_NO_INPUT */

#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif
	{
	if ( ! yy_current_buffer )
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_init_buffer( yy_current_buffer, input_file );
	yy_load_buffer_state();
	}


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif
	{
	if ( yy_current_buffer == new_buffer )
		return;

	if ( yy_current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
	}


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif
	{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
	}


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
	}


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif
	{
	if ( ! b )
		return;

	if ( b == yy_current_buffer )
		yy_current_buffer = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yy_flex_free( (void *) b->yy_ch_buf );

	yy_flex_free( (void *) b );
	}



#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif


	{
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

#if YY_ALWAYS_INTERACTIVE
	b->yy_is_interactive = 1;
#else
#if YY_NEVER_INTERACTIVE
	b->yy_is_interactive = 0;
#else
	b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
#endif
#endif
	}


#ifdef YY_USE_PROTOS
void yy_flush_buffer( YY_BUFFER_STATE b )
#else
void yy_flush_buffer( b )
YY_BUFFER_STATE b;
#endif

	{
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == yy_current_buffer )
		yy_load_buffer_state();
	}


#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )
#else
YY_BUFFER_STATE yy_scan_buffer( base, size )
char *base;
yy_size_t size;
#endif
	{
	YY_BUFFER_STATE b;

	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b );

	return b;
	}
#endif


#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_string( yyconst char *yy_str )
#else
YY_BUFFER_STATE yy_scan_string( yy_str )
yyconst char *yy_str;
#endif
	{
	int len;
	for ( len = 0; yy_str[len]; ++len )
		;

	return yy_scan_bytes( yy_str, len );
	}
#endif


#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )
#else
YY_BUFFER_STATE yy_scan_bytes( bytes, len )
yyconst char *bytes;
int len;
#endif
	{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;

	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) yy_flex_alloc( n );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
	}
#endif


#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void yy_push_state( int new_state )
#else
static void yy_push_state( new_state )
int new_state;
#endif
	{
	if ( yy_start_stack_ptr >= yy_start_stack_depth )
		{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof( int );

		if ( ! yy_start_stack )
			yy_start_stack = (int *) yy_flex_alloc( new_size );

		else
			yy_start_stack = (int *) yy_flex_realloc(
					(void *) yy_start_stack, new_size );

		if ( ! yy_start_stack )
			YY_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
	}
#endif


#ifndef YY_NO_POP_STATE
static void yy_pop_state()
	{
	if ( --yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
	}
#endif


#ifndef YY_NO_TOP_STATE
static int yy_top_state()
	{
	return yy_start_stack[yy_start_stack_ptr - 1];
	}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void yy_fatal_error( yyconst char msg[] )
#else
static void yy_fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
	}



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
yyconst char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen( yyconst char *s )
#else
static int yy_flex_strlen( s )
yyconst char *s;
#endif
	{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
	}
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( yy_size_t size )
#else
static void *yy_flex_alloc( size )
yy_size_t size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, yy_size_t size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
yy_size_t size;
#endif
	{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
	}

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}

#if YY_MAIN
int main()
	{
	yylex();
	return 0;
	}
#endif
#line 230 "../src/C.l"


void set_lex_input(char *str)
{
   static bool firstCall = true;
   YY_BUFFER_STATE bp;
   
   //db removed firstcall check
   if(!firstCall) dynC_flush_buffer(YY_CURRENT_BUFFER);
   yycolumn = 0;
   line_num = 1;
   
   input_str = str;
   bp = dynC_scan_string(str);
   firstCall = false;
}

